package Package1;


import java.io.File;
import java.io.IOException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class IEEE1599Convert {

    public static void main(String[] args) {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        factory.setValidating(false);
        factory.setIgnoringElementContentWhitespace(true);
        try {
            DocumentBuilder builder = factory.newDocumentBuilder();
            File file = new File("gounod_ave_maria.xml");
            Document docInput = builder.parse(file);
            Document docOutput = builder.newDocument();
            Element rootOutput = docOutput.createElement("melodia");
            docOutput.appendChild(rootOutput);

            NodeList voicesList = docInput.getElementsByTagName("voice");
            Node voiceNode = null;
            for (int i = 0; i < voicesList.getLength() && (voiceNode = voicesList.item(i)) != null; i++) {
                NodeList notesRestsList = voiceNode.getChildNodes();
                for (int j = 0; j < notesRestsList.getLength(); j++) {
                    if (notesRestsList.item(j).getNodeName().equals("chord")) {
                        Element chordElem = (Element) notesRestsList.item(j);
                        Element durationElem = (Element) chordElem.getElementsByTagName("duration").item(0);

                        NodeList pitchesNodeList = chordElem.getElementsByTagName("pitch");
                        Node pitchNode = null;
                        for (int k = 0; k < pitchesNodeList.getLength() && (pitchNode = pitchesNodeList.item(k)) != null; k++) {
                            Element pitchElem = (Element) pitchNode;
                            Element nota = docOutput.createElement("nota");
                            
                            Element altezza = docOutput.createElement("altezza");
                            altezza.setAttribute("nome", pitchElem.getAttribute("step"));
                            altezza.setAttribute("alterazione", pitchElem.getAttribute("actual_accidental"));
                            altezza.setAttribute("ottava", pitchElem.getAttribute("octave"));

                            nota.appendChild(altezza);

                            Element durata = docOutput.createElement("durata");
                            durata.setAttribute("num", durationElem.getAttribute("num"));
                            durata.setAttribute("den", durationElem.getAttribute("den"));
                            // Attenzione: anche se avesse lo stesso nome di attributo, NON è possibile fare:
                            // durata.setAttributeNode(durationElem.getAttributeNode("num"));
                            // perché si tratta di nodi di documenti diversi

                            nota.appendChild(durata);
                            rootOutput.appendChild(nota);
                        }
                    }
                    else if (notesRestsList.item(j).getNodeName().equals("rest")) {
                        Element restElem = (Element) notesRestsList.item(j);
                        Element durationElem = (Element) restElem.getElementsByTagName("duration").item(0);
                        Element pausa = docOutput.createElement("pausa");
                            
                        Element durata = docOutput.createElement("durata");
                        durata.setAttribute("num", durationElem.getAttribute("num"));
                        durata.setAttribute("den", durationElem.getAttribute("den"));

                        pausa.appendChild(durata);
                        rootOutput.appendChild(pausa);
                    }
                }
            }

            // salvataggio
            try {
                Result output = new StreamResult(new File("convertedMelody.xml"));
                Source input = new DOMSource(docOutput);

                TransformerFactory tf = TransformerFactory.newInstance();
                Transformer t = tf.newTransformer();
                t.setOutputProperty(OutputKeys.INDENT, "yes");
                t.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "3");

                t.transform(input, output);
            } catch (TransformerException ex) {
                System.out.println("Salvataggio non riuscito");
                System.exit(1);
            }

        } catch (ParserConfigurationException | SAXException | IOException e) {
            System.out.println("Errore nell'elaborazione del file");
            System.exit(1);
        }

    }

}
