package Package1;


import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;
import java.util.concurrent.ExecutionException;
import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.SwingWorker;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class IEEE1599Timer extends javax.swing.JFrame {
    String originalOpenButtonText;
    Timer timer;
    ArrayList<Event> eventsList;
    DefaultListModel<String> listModel;
    
    class Event {
        long timing;
        String id;
                
        public Event(long timing, String id) {
            this.timing = timing;
            this.id = id;
        }
    }
    
    /**
     * Creates new form XPathAnalysisSwing
     */
    public IEEE1599Timer() {
        initComponents();
        originalOpenButtonText = jButtonOpenFile.getText();
        timer = new Timer();
        listModel = new DefaultListModel();
        jListEvents.setModel(listModel);
        eventsList = new ArrayList<>();
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabelCurrentFile = new javax.swing.JLabel();
        jButtonOpenFile = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jListEvents = new javax.swing.JList<>();
        jLabel2 = new javax.swing.JLabel();
        jButtonPlay = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel1.setText("File corrente: ");

        jLabelCurrentFile.setText("-");

        jButtonOpenFile.setText("Apri file IEEE 1599");
        jButtonOpenFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOpenFileActionPerformed(evt);
            }
        });

        jScrollPane1.setViewportView(jListEvents);

        jLabel2.setText("Eventi");

        jButtonPlay.setText("Play");
        jButtonPlay.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonPlayActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButtonOpenFile)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelCurrentFile)
                        .addGap(0, 343, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jButtonPlay))
                            .addComponent(jScrollPane1))
                        .addContainerGap())))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonOpenFile)
                    .addComponent(jLabel1)
                    .addComponent(jLabelCurrentFile))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jButtonPlay)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 357, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonOpenFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOpenFileActionPerformed
        JFileChooser chooser = new JFileChooser();
        chooser.setFileFilter(new FileNameExtensionFilter("Documenti IEEE 1599", "xml"));
        if (chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            timer.cancel();
            jLabelCurrentFile.setText(chooser.getSelectedFile().getName());
            jButtonOpenFile.setEnabled(false);
            jButtonOpenFile.setText("Caricamento...");
            jButtonPlay.setEnabled(false);
            jListEvents.setEnabled(false);
            listModel.clear();
            eventsList.clear();
            SwingWorker worker = new SwingWorker<Boolean, Event>() {
                @Override
                public Boolean doInBackground() {
                    try {
                        DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
                        docFactory.setValidating(false);
                        DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
                        Document doc = docBuilder.parse(chooser.getSelectedFile().getPath());

                        NodeList events = doc.getElementsByTagName("event");
                        Node node = null;
                        long totalTiming = 0;
                        for (int i = 0; i < events.getLength() && (node = events.item(i)) != null; i++) {
                            Element event = (Element)node;
                            String id = event.getAttribute("id");
                            String timingS = event.getAttribute("timing");
                            int timing = Integer.parseInt(timingS);
                            totalTiming += timing;
                            publish(new Event(totalTiming, id));
                        }

                    } catch (ParserConfigurationException | NumberFormatException | SAXException | IOException ex) {
                        return false;
                    }
                    return true;
                }
                
                @Override
                protected void process(List<Event> events) {
                    for (Event e : events)
                        eventsList.add(e);
                }
                
                @Override
                protected void done() {
                    try {
                        if (!get())
                            JOptionPane.showMessageDialog(null, "Errore nel parsing del file IEEE 1599", "Errore", JOptionPane.ERROR_MESSAGE);
                    } catch (InterruptedException | ExecutionException ex) {
                        JOptionPane.showMessageDialog(null, "Errore nel parsing del file IEEE 1599", "Errore", JOptionPane.ERROR_MESSAGE);
                    }
                    jButtonOpenFile.setEnabled(true);
                    jButtonOpenFile.setText(originalOpenButtonText);
                    jButtonPlay.setEnabled(true);
                    jListEvents.setEnabled(true);
                }
            };
            worker.execute();
        }
    }//GEN-LAST:event_jButtonOpenFileActionPerformed

    private void jButtonPlayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonPlayActionPerformed
        timer.cancel();
        timer = new Timer();
        listModel.clear();
        for (Event e : eventsList) {
            timer.schedule(new TimerTask() {
                @Override
                public void run() {
                    listModel.addElement(e.id + " (" + e.timing + " ms)");
                    jListEvents.ensureIndexIsVisible(listModel.size() - 1);
                }
            }, e.timing);
        }
    }//GEN-LAST:event_jButtonPlayActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels())
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(XPathAnalysisSwing.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(XPathAnalysisSwing.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(XPathAnalysisSwing.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(XPathAnalysisSwing.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new IEEE1599Timer().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonOpenFile;
    private javax.swing.JButton jButtonPlay;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabelCurrentFile;
    private javax.swing.JList<String> jListEvents;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
}
