package Package1;


import java.io.File;
import java.io.IOException;
import java.util.TreeMap;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class XMLstats {

    public static void main(String[] args) {

        TreeMap<Integer, Integer> rhythmMap = new TreeMap<>();
        int[] pitchStats = {0, 0, 0, 0, 0, 0, 0};

        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        factory.setValidating(false);
        factory.setIgnoringElementContentWhitespace(true);
        try {
            DocumentBuilder builder = factory.newDocumentBuilder();
            File file = new File("gounod_ave_maria.xml");
            Document doc = builder.parse(file);

            // altezze
            NodeList pitchNodeList = doc.getElementsByTagName("pitch");
            // Non è possibile usare un foreach perché NodeList non implementa l'interfaccia Iterable
            Node currentNode = null;
            for (int i = 0; i < pitchNodeList.getLength() && (currentNode = pitchNodeList.item(i)) != null; i++) {
                Element pitchElem = (Element) currentNode;
                if (!pitchElem.getAttribute("step").equals("")) {
                    char currentPitch = pitchElem.getAttribute("step").toUpperCase().charAt(0);
                    int arrayIndex = (int) currentPitch - 'A';
                    pitchStats[arrayIndex]++;
                }
            }

            // durate
            NodeList rhythmNodeList = doc.getElementsByTagName("duration");
            for (int i = 0; i < rhythmNodeList.getLength() && (currentNode = rhythmNodeList.item(i)) != null; i++) {
                Element rhythmElem = (Element) currentNode;
                if (rhythmElem.getAttributeNode("den") != null) {
                    if (rhythmElem.getAttributeNode("num") != null) {
                        int currentNum = Integer.parseInt(rhythmElem.getAttributeNode("num").getTextContent());
                        if (currentNum != 1)
                            continue;
                    }
                    int currentDen = Integer.parseInt(rhythmElem.getAttributeNode("den").getTextContent());
                    int newCounterValue = 0;
                    if (rhythmMap.containsKey(currentDen))
                        newCounterValue = rhythmMap.get(currentDen);
                    rhythmMap.put(currentDen, ++newCounterValue);
                }
            }

        } catch (ParserConfigurationException | SAXException | IOException e) {
            System.out.println("Errore nell'elaborazione del file");
            System.exit(1);
        }

        for (int i = 0; i < pitchStats.length; i++)
            System.out.println("Occorrenze dell'altezza " + (char) ('A' + i) + ": " + pitchStats[i]);

        System.out.println();

        for (int key : rhythmMap.keySet())
            System.out.println("Occorrenze della durata 1/" + key + ": " + rhythmMap.get(key));
    }

}
